﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Windows.Markup;

namespace GridComboBoxDemo
{
    [DefaultProperty("Columns")]
    [ContentProperty("Columns")]
    public class GridComboBox : ComboBox
    {
        private GridViewColumnCollection columns;
        static GridComboBox()
        {
            DefaultStyleKeyProperty.OverrideMetadata(typeof(GridComboBox), new FrameworkPropertyMetadata(typeof(GridComboBox)));
        }

        [DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
        public GridViewColumnCollection Columns
        {
            get
            {
                if (this.columns == null)
                {
                    this.columns = new GridViewColumnCollection();
                }
                return this.columns;
            }
        }

        protected override DependencyObject GetContainerForItemOverride()
        {
            return new GridComboBoxItem();
        }

        protected override bool IsItemItsOwnContainerOverride(object item)
        {
            return item is GridComboBoxItem;
        }
    }

    public class GridComboBoxItem : ComboBoxItem
    {
        static GridComboBoxItem()
        {
            DefaultStyleKeyProperty.OverrideMetadata(typeof(GridComboBoxItem), new FrameworkPropertyMetadata(typeof(GridComboBoxItem)));
        }
    }
}
